var canvas;
var cntx;

function init(){
    canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    initialiseFlags();
    showAppTitle();
    initialValues();
    initialiseGUI();
    initialiseEvents();
    selectFlag();
    drawBasicScreen();
}
      
function initialiseEvents(){
    $("#visualisation").on("mousemove",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseMove();
    });

    $("#visualisation").on("mouseup",function(evt){
        evt.preventDefault();
        evt.stopPropagation();
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseUp();
        mouseButtonPressed=noMouseButtonPressed;
    });

    $("#visualisation").on("mousedown",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        mouseButtonPressed=evt.button;
        handleMouseDown();
    });

    $(document).on("keyup keydown",function(k){
        shiftPressed=k.shiftKey;
        handleShape();
        drawBasicScreen();
    });
    
    $(document).contextmenu(function(){
        return false;
    });
}

function initialiseGUI(){
    var i,j;
    for(i=0;i<noOfTools;i++){
        j=i+1;
        drawToolsArray[i]=document.getElementById("tools"+j);
        drawToolsArray[i+noOfTools]=document.getElementById("tools"+j+"bw");
    }
    for(i=0;i<noOfTools;i++){
        toolLeft[i]=BackStepLeft+BackStepWidth+border+i*(toolWidth+5);
    }
    toolTop=BottomPanelTop+2;
    paletteLeft=400;
    paletteTop=BottomPanelTop+6;
    initialisePalette();
    
    mEntry[0]="Διαγραφή";
    mEntry[1]="Μεταφορά Πίσω";
    mEntry[2]="Μεταφορά Εμπρός";
    mEntry[3]="Νέο Χρώμα";
    mEnabled[0]=true;
    mEnabled[1]=true;
    mEnabled[2]=true;
    mEnabled[3]=true;
}

function initialValues(){
    TitleTOP=20;
    TitleWIDTH=550;
    TitleLEFT=(width-TitleWIDTH)/2;
    TitleHEIGHT=35;
    imgLogo=document.getElementById("Logo");
    width=canvas.width;
    height=canvas.height;

    BottomPanelTop=height-BottomPanelHeight;
    logoLeft=width-logoWidth-5;
    logoTop=BottomPanelTop+(BottomPanelHeight-logoHeight)/2;
    imgNxtStepEnabled=document.getElementById("ButtonEnabledSmall");
    imgNxtStepSelected=document.getElementById("ButtonSelSmall");
    imgBackStepEnabled=document.getElementById("BackEnabledSmall");
    imgBackStepSelected=document.getElementById("BackSelSmall");
    nxtStepLeft=width-nxtStepWidth-15-logoWidth;
    nxtStepTop=BottomPanelTop+20;
    BackStepLeft=2;
    BackStepTop=nxtStepTop;
}

function drawBasicScreen(){
    cntx.clearRect(0,0,canvas.width,canvas.height);
    //Φόντα οθόνης
    drawIntroImage();
    if(introStep==introLastStep){
        $("#sourceCodeDIV").show();
        $("#flagSelectorDIV").show();
        $("#colorSelectorDIV").show();
        if($("#gridVisible").prop("checked")){
            drawGrid();
        }
        drawLibrary();
        //Διαγραφή τμημάτων που βρίσκονται εκτός ορίων
        cntx.fillStyle="rgb(255,255,255)";
        cntx.beginPath();
        cntx.fillRect(0,0,flagLeft,height);
        cntx.fillRect(flagLeft+flagWidth,0,width-(flagLeft+flagWidth),height);
        cntx.fillRect(0,0,width,flagTop);
        cntx.fillRect(0,flagTop+flagHeight,width,width+height-(flagTop+flagHeight));
        cntx.fill();
        showColorInfo();
        showSelectedShapeInfo();
        drawMenu();
    }
    else{
        $("#flagSelectorDIV").hide();
        $("#sourceCodeDIV").hide();
        $("#colorSelectorDIV").hide();
    }
    drawPanels();
    drawLogoImage();
    if(introStep==introLastStep){
        drawFlag();
        drawToolbox();
        $("#controlsDIV").show();
        //drawPalette();
        showProgram();
        cnvsWrite("rgb(0,0,255)",16,"Arial",-1,480,additionalInfo);
        if(mouseInsideFlag()){
            cnvsWrite(LetterColor,coordsFontSize,"Arial",500,TopPanelHeight+2*coordsFontSize,"x="+(mx-flagLeft)+" , y="+(my-flagTop));
        }
    }
    else{
        $("#controlsDIV").hide();
    }
    showUserPrompts();
}

function mouseInsideFlag(){
    return mx>=flagLeft && mx<=flagLeft+flagWidth && my>=flagTop && my<=flagTop+flagHeight;
}

function drawIntroImage(){
    if(introStep<introLastStep){
        Intro=document.getElementById("img"+introStep);
    }
    else{
        Intro=document.getElementById("img1");
    }
    picTop=(height-Intro.height)/2;

    if(introStep<introLastStep){
        cntx.drawImage(Intro,1,picTop);
    }
    else{
        cntx.fillStyle="rgb(255,255,255)";
        cntx.beginPath();
        cntx.fillRect(1,picTop,width-2,Intro.height);
    }
}

function drawPanels(){
    var lowRectTop=picTop+Intro.height+1;
    cntx.clearRect(0,0,width,picTop-1);
    cntx.clearRect(0,lowRectTop,width,height-lowRectTop);
    cntx.strokeStyle="black";
    cntx.beginPath();
    //πλαίσιο καμβά
    cntx.rect(0,0,width,height);
    //άνω πλαίσιο
    cntx.rect(0,0,width,picTop-1);
    //κάτω πλαίσιο
    cntx.rect(0,lowRectTop,width,height-lowRectTop);
    cntx.stroke();
    cnvsWrite(LetterColor,35,"Arial",-1,TitleTOP+TitleHEIGHT,appTitle);
    if(introStep<introLastStep) drawButtonNext();
    if(introStep>1) drawButtonBack();
}

function drawLogoImage(){
    var picTop=(height-Intro.height)/2;
    var lowRectTop=picTop+Intro.height+1;
    var logoTop=lowRectTop+((height-lowRectTop)-imgLogo.height)/2;
    cntx.drawImage(imgLogo,width-imgLogo.width-2,logoTop);
}

function showHTML(){
    window.open("index_DS_I_DS_II.html","_blank");
}

function drawButtonNext(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonNextHover()){
        cntx.drawImage(imgNxtStepSelected,nxtStepLeft,nxtStepTop);
    }
    else{
        cntx.drawImage(imgNxtStepEnabled,nxtStepLeft,nxtStepTop);
    }
}

function buttonNextHover(){
    if (mx>=nxtStepLeft && mx<=nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<=nxtStepTop+nxtStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function drawButtonBack(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonBackHover()){
        cntx.drawImage(imgBackStepSelected,BackStepLeft,BackStepTop);
    }
    else{
        cntx.drawImage(imgBackStepEnabled,BackStepLeft,BackStepTop);
    }
}

function buttonBackHover(){
    if (mx>=BackStepLeft && mx<=BackStepLeft+BackStepWidth && my>=BackStepTop && my<=BackStepTop+BackStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function cnvsWrite(clr,fontSize,fontName,txtX,txtY,txt){       
    cntx.font=fontSize+"px "+fontName;
    cntx.fillStyle=clr;
    if(txtX<0) txtX=(canvas.width-cntx.measureText(txt).width)/2;
    cntx.fillText(txt,txtX,txtY);
}

function handleMouseDown(){
    if(introStep>=introLastStep){
        if(my>TopPanelHeight && my<BottomPanelTop && !mVisible){
            if(shapeHover>-1){
                checkResizeHover(shapeHover);
                if(libShape[shapeHover][6]>-1){
                    resizingShape=true;
                }
                else{
                    draggingShape=true;
                    shapeToDrag=shapeHover;
                }
                if(shapeToDrag>-1){
                    dDragX=mx-libShape[shapeToDrag][1];
                    dDragY=my-libShape[shapeToDrag][2];
                }
            }
            else{
                shapeToDrag=-1;
                drawing=true;
                currentShape++;
                libShape[currentShape][0]=selectedTool;
                libShape[currentShape][1]=mx;
                libShape[currentShape][2]=my;
                if(selectedTool==0){
                    libShape[currentShape][3]=mx;
                    libShape[currentShape][4]=my;
                }
                else{
                    libShape[currentShape][3]=0;
                    libShape[currentShape][4]=0;
                }
                libShape[currentShape][5]=selectedColorIndex;
				libShape[currentShape][7]=parseInt($("#HscrRed").val());
				libShape[currentShape][8]=parseInt($("#HscrGreen").val());
				libShape[currentShape][9]=parseInt($("#HscrBlue").val());
            }
        }
        else{
            shapeToDrag=-1;
        }
    }    
    drawBasicScreen();
}

function handleMouseMove(){
    if(mx>=logoLeft && mx<logoLeft+logoWidth && my>=logoTop && my<logoTop+logoHeight){
        imgLogo=document.getElementById("LogoSel");
    }
    else{
        imgLogo=document.getElementById("Logo");
    }
    if(introStep>=introLastStep){
        //Διαχείριση σχημάτων με το ποντίκι
        if(mouseButtonPressed==0){
            handleShape();
        }
        else{
            canvas.style.cursor="default";
            if(mVisible && menuHover()){//Διαχείριση menu με το ποντίκι
              mHoverLine=parseInt((my-mTop)/menuFontSize);
              if(mHoverLine<0 || mHoverLine>=menuEntries) mHoverLine=-1;
            }
            else{//Διαχείριση εργαλειοθήκης με το ποντίκι
                hoverTool();
                if(paletteHover(mx,my) || toolHovering>-1){
                    canvas.style.cursor="pointer";
                }
                checkShapeHover();
                if(shapeHover>-1){
                    canvas.style.cursor="move";
                    checkResizeHover(shapeHover);
                    if(libShape[shapeHover][6]>-1){
                        if(libShape[shapeHover][0]==0){//Γραμμή
                            canvas.style.cursor="crosshair";
                        }
                        else{//Υπόλοιπα σχήματα
                            if(libShape[shapeHover][6]<2){
                                canvas.style.cursor="n-resize";
                            }
                            else{
                                canvas.style.cursor="e-resize";
                            }
                        }
                    }
                }
            }
        }
    }
    drawBasicScreen();
}

function handleMouseUp(){
    if(mx>=logoLeft && mx<logoLeft+logoWidth && my >=logoTop && my<logoTop+logoHeight) {
        showHTML();
    }
    if(mx>=nxtStepLeft && mx<nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<nxtStepTop+nxtStepHeight && introStep<introLastStep) {
        mVisible=false;
        introStep++;
        if(introStep==introLastStep){
            selectedTool=0;
            mEnabled[0]=true;
            currentShape=-1;
        }
        else{
            selectedTool=-1;
        }
    }
    if(mx>=BackStepLeft && mx<BackStepLeft+BackStepWidth && my>=BackStepTop && my<BackStepTop+BackStepHeight && introStep>1){
        introStep--;
    }

    if(introStep>=introLastStep){
        if(toolHovering>-1){
            selectedTool=toolHovering;
        }
        if(paletteHover(mx,my)){
            selectPaletteColor(mx);
        }
        draggingShape=false;
        resizingShape=false;
        if(mVisible){
            if(menuHover()){
                if(mEnabled[mHoverLine]) performMenuCommand();
            }
            else{
                mVisible=false;
            }
        }
        else if(mouseButtonPressed==rightMouseButtonPressed && shapeHover>-1){
            if(introStep==introLastStep){
                if(libShape[shapeHover][0]>500){
                    mEnabled[3]=false;
                }
                else{
                    mEnabled[3]=true;
                }
            }
            if(introStep==introLastStep){
                mVisible=true;
            }
            mLeft=mx;
            mTop=my;
        }
        if(drawing){//Απελευθέρωση ποντικιού εν μέσω σχεδίασης
            drawing=false;
            if(libShape[currentShape][0]==0 && libShape[currentShape][1]==libShape[currentShape][3] && libShape[currentShape][2]==libShape[currentShape][4]){
                currentShape--;//Ακύρωση "αδιάστατης" Γραμμής
            }
            else if(libShape[currentShape][3]==0 && libShape[currentShape][4]==0){
                currentShape--;//Ακύρωση Υπόλοιπων Σχημάτων
            }
            else{
                if(libShape[currentShape][0]>0) trimNegatives(currentShape);
            }
        }
        else if(shapeToDrag>-1){
            trimNegatives(shapeToDrag);
            libShape[shapeToDrag][6]=-1;
        }
        selectedShapeInfo="";
    }
    
    drawBasicScreen();
}

function showUserPrompts(){
    var vTxtOffset=15;
    var hTxtOffset=BackStepLeft+BackStepWidth+border;
    var promptYCoord;
    if (introStep==introLastStep) {
        promptYCoord=BottomPanelTop+43;
        cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Ζωγράφισε μέσα στο πλαίσιο τη σημαία που βλέπεις και δες τις αντίστοιχες εντολές να καταγράφονται.");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Μπορείς να βρεις το συντομότερο πρόγραμμα που σχεδιάζει τη ζητούμενη σημαία;");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Εντόπισε το όνομα της αντίστοιχης χώρας από τη λίστα.");
    }
}

function initialisePalette(){
    paletteR[0]=0; paletteG[0]=0; paletteB[0]=0;
    paletteR[1]=90; paletteG[1]=90; paletteB[1]=90;
    paletteR[2]=255; paletteG[2]=0; paletteB[2]=0;
    paletteR[3]=0; paletteG[3]=255; paletteB[3]=0;
    paletteR[4]=0; paletteG[4]=0; paletteB[4]=255;
    paletteR[5]=130; paletteG[5]=0; paletteB[5]=100;
    paletteR[6]=240; paletteG[6]=140; paletteB[6]=70;
    paletteR[7]=240; paletteG[7]=80; paletteB[7]=70;
    paletteR[8]=160; paletteG[8]=45; paletteB[8]=170;
    paletteR[9]=160; paletteG[9]=45; paletteB[9]=225;
    paletteR[10]=100; paletteG[10]=60; paletteB[10]=200;
    paletteR[11]=60; paletteG[11]=130; paletteB[11]=200;
    paletteR[12]=60; paletteG[12]=175; paletteB[12]=200;
    paletteR[13]=160; paletteG[13]=175; paletteB[13]=220;
    paletteR[14]=210; paletteG[14]=180; paletteB[14]=150;
    paletteR[15]=255; paletteG[15]=255; paletteB[15]=0;
}

function drawPalette(){
    for(var i=0;i<noOfPaletteColors;i++){
        cntx.fillStyle="rgb("+paletteR[i]+","+paletteG[i]+","+paletteB[i]+")";
        cntx.beginPath();
        cntx.fillRect(paletteLeft+PaletteSlotSize*i,paletteTop,PaletteSlotSize,PaletteSlotSize);
        cntx.fill();
    }
    cntx.strokeStyle="rgb(255,255,255)";
    var X1=paletteLeft+PaletteSlotSize*selectedColorIndex;
    var Y1=paletteTop;
    var X2=X1+PaletteSlotSize;
    var Y2=Y1+PaletteSlotSize;
    cntx.beginPath();
    cntx.moveTo(X1,Y1);
    cntx.lineTo(X2,Y2);
    cntx.moveTo(X1,Y2);
    cntx.lineTo(X2,Y1);
    cntx.stroke();
}

function paletteHover(){
    return (mx>=paletteLeft && mx<paletteLeft+noOfPaletteColors*PaletteSlotSize && my>=paletteTop && my<=paletteTop+PaletteSlotSize);
}

function selectPaletteColor(){
    selectedColorIndex=parseInt((mx-paletteLeft)/PaletteSlotSize);
}

function drawToolbox(){
    var iTool;
    for(var i=0;i<noOfTools;i++){
        if(toolHovering==i || selectedTool==i){
            iTool=i;
        }
        else{
            iTool=i+noOfTools;
        }
        drawTool(iTool);
    }
}

function drawTool(iTool){
    cntx.drawImage(drawToolsArray[iTool],toolLeft[iTool % noOfTools],toolTop);
    if(iTool==selectedTool){
        cntx.strokeStyle="rgb(0,0,255)";
        cntx.beginPath();
        cntx.rect(toolLeft[iTool]-1,toolTop-1,toolWidth+2,toolHeight+2);
        cntx.stroke();
    }    
}

function hoverTool(){
    var i;
    var found=false;
    i=0;
    while(i<noOfTools && !found){
        found=mx>=toolLeft[i] && mx<=toolLeft[i]+toolWidth && my>=toolTop && my<=toolTop+toolHeight;
        i++;
    }
    if(found){
        toolHovering=i-1;
    }
    else {
        toolHovering=-1;
    }
}

function menuHover(){
    if(mx>=mLeft && mx<=mLeft+mWidth && my>=mTop && my<=mTop+menuEntries*menuFontSize){
        return true;
    }
    else{
        return false;
    }
}

function checkResizeHover(i){
    var X1,X2,Y1,Y2,ID=-1;
    if(libShape[i][0]==0){//Γραμμή
        //Αρχή
        X1=libShape[i][1]-selectorSize/2;
        X2=libShape[i][1]+selectorSize/2;
        Y1=libShape[i][2]-selectorSize/2;
        Y2=libShape[i][2]+selectorSize/2;
        if (mx>=X1 && mx<=X2 && my>=Y1 && my<=Y2) ID=0;
        //Τέλος
        X1=libShape[i][3]-selectorSize/2;
        X2=libShape[i][3]+selectorSize/2;
        Y1=libShape[i][4]-selectorSize/2;
        Y2=libShape[i][4]+selectorSize/2;
        if (mx>=X1 && mx<=X2 && my>=Y1 && my<=Y2) ID=1;
    }
    else if(libShape[i][0]<500){//Υπόλοιπα Σχήματα
        //Πάνω
        X1=libShape[i][1]+(libShape[i][3]-selectorSize)/2;
        X2=libShape[i][1]+(libShape[i][3]+selectorSize)/2;
        Y1=libShape[i][2]-selectorSize/2;
        Y2=libShape[i][2]+selectorSize/2;
        if (mx>=X1 && mx<=X2 && my>=Y1 && my<=Y2) ID=0;
        //Κάτω
        X1=libShape[i][1]+(libShape[i][3]-selectorSize)/2;
        X2=libShape[i][1]+(libShape[i][3]+selectorSize)/2;
        Y1=libShape[i][2]+libShape[i][4]-selectorSize/2;
        Y2=libShape[i][2]+libShape[i][4]+selectorSize/2;
        if (mx>=X1 && mx<=X2 && my>=Y1  && my<=Y2) ID=1;;
        //Αριστερά
        X1=libShape[i][1]-selectorSize/2;
        X2=libShape[i][1]+selectorSize/2;
        Y1=libShape[i][2]+(libShape[i][4]-selectorSize)/2;
        Y2=libShape[i][2]+(libShape[i][4]+selectorSize)/2;
        if (mx>=X1 && mx<=X2 && my>=Y1  && my<=Y2) ID=2;
        //Δεξιά
        X1=libShape[i][1]+libShape[i][3]-selectorSize/2;
        X2=libShape[i][1]+libShape[i][3]+selectorSize/2;
        Y1=libShape[i][2]+(libShape[i][4]-selectorSize)/2;
        Y2=libShape[i][2]+(libShape[i][4]+selectorSize)/2;
        if (mx>=X1 && mx<=X2 && my>=Y1  && my<=Y2) ID=3;
    }
    libShape[i][6]=ID;
}

function drawMenu(){
    var i;
    if(mVisible){
        //Υπολογισμός πλάτους
        mWidth=0;
        cntx.font=menuFontSize+"px Arial";
        var mnEntrWdt=0;
        for(i=0;i<menuEntries;i++){
            if(cntx.measureText(mEntry[i]).width>mWidth) mWidth=cntx.measureText(mEntry[i]).width;
        }
        mWidth=mWidth+4;
        mLnHeight=menuFontSize+1;
        //Σχεδίαση γενικού φόντου και περιγράμματος
        cntx.fillStyle="rgb(255,255,255)";
        cntx.strokeStyle="rgb(0,0,0)";
        roundRect(mLeft,mTop,mWidth,mLnHeight*menuEntries,mLnHeight,true,true);
        //Σχεδίαση φόντου επιλογής
        if(mHoverLine>-1){
            cntx.fillStyle="rgb(255,255,0)";
            roundRect(mLeft+1,mTop+mHoverLine*menuFontSize+1,mWidth-2,mLnHeight,mLnHeight,true,false);
        }

        //Εμφάνιση επιλογών
        var colorToUse="";
        for(i=0;i<menuEntries;i++){
            if(mEnabled[i]){
                if(i==mHoverLine){
                    colorToUse="rgb(0,0,255)";
                }
                else{
                    colorToUse="rgb(0,0,0)";
                }
            }
            else{
                colorToUse="rgb(200,200,200)";
            }
            cnvsWrite(colorToUse,menuFontSize,"Arial",mLeft+2,mTop+(i+1)*menuFontSize,mEntry[i]);
        }
    }
}

function performMenuCommand(){
    if(mHoverLine==0){ //Διαγραφή
        if(shapeHover!=currentShape){
            for(var i=shapeHover;i<currentShape;i++){
                for(var k=0;k<7;k++){
                    libShape[i][k]=libShape[i+1][k];
                }
            }
        }
        currentShape--;
    }
    else if(mHoverLine==1){ //Μεταφορά πίσω
        if(shapeHover>0){ //Αν δεν είναι το πρώτο σχήμα
            swapShapes(shapeHover,shapeHover-1);
        }
    }
    else if(mHoverLine==2){ //Μεταφορά εμπρός
        if(shapeHover<currentShape){ //Αν δεν είναι το πρώτο σχήμα
            swapShapes(shapeHover,shapeHover+1);
        }
    }
    else if(mHoverLine==3){ //Χρώμα
        //libShape[shapeHover][5]=selectedColorIndex;
		libShape[shapeHover][7]=parseInt($("#HscrRed").val());
		libShape[shapeHover][8]=parseInt($("#HscrGreen").val());
		libShape[shapeHover][9]=parseInt($("#HscrBlue").val());
    }
    mVisible=false;
    mHoverLine=-1;
}

function swapShapes(i,j){
    var temp,k;
    for(k=0;k<10;k++){
        temp=libShape[i][k];
        libShape[i][k]=libShape[j][k];
        libShape[j][k]=temp;
    }
}

function checkShapeHover(){
    var i=currentShape;
    var shp=-1;
    while(i>-1 && shp==-1){
        if(shpHover(i)) shp=i;
        i--;
    }
    shapeHover=shp;
}

function shpHover(i){
    if(libShape[i][0]==0) {//Γραμμή
        var Xmin=Math.min(libShape[i][1],libShape[i][3]);
        var Xmax=Math.max(libShape[i][1],libShape[i][3]);
        if(mx>=Xmin && mx<=Xmax){
            if(libShape[i][1]==libShape[i][3]){//Κατακόρυφη
                if(mx==libShape[i][1]){
                    return true;
                }
                else{
                    return false;
                }
            }
            else if(libShape[i][2]==libShape[i][4]){//Οριζόντια
                if(my==libShape[i][2]){
                    return true;
                }
                else{
                    return false;
                }
            }
            else{//Πλάγια
                var Acoef,Bcoef;
                var Yline;
                Acoef=((libShape[i][4]-libShape[i][2]))/((libShape[i][3]-libShape[i][1]));
                Bcoef=libShape[i][2]-Acoef*libShape[i][1];
                Yline=parseInt(Acoef*mx+Bcoef);
                if(Math.abs(Yline-my)<=selectorSize){
                    return true;
                }
                else{
                    return false;
                }
            }
        }
        else{ // Ποντίκι εκτός οριζόντιων ορίων γραμμής
            return false;
        }
    }
    if(mx>=libShape[i][1] && mx<=libShape[i][1]+libShape[i][3] && my>=libShape[i][2] && my<=libShape[i][2]+libShape[i][4]){
        return true;
    }
    else{
        return false;
    }
}

function showSelectedShapeInfo(){
    cnvsWrite("rgb(0,0,0)",fontSize+4,"Arial",10,BottomPanelTop-(fontSize+4),selectedShapeInfo);
}

function handleShape(){
    if(shapeToDrag>-1){
        if(libShape[shapeToDrag][6]==-1){ //Move
            if(libShape[shapeToDrag][0]==0){ //Γραμμή                      
                var lineWidth=libShape[shapeToDrag][3]-libShape[shapeToDrag][1];
                var lineHeight=libShape[shapeToDrag][4]-libShape[shapeToDrag][2];
                libShape[shapeToDrag][1]=mx-dDragX;
                libShape[shapeToDrag][2]=my-dDragY;
                libShape[shapeToDrag][3]=libShape[shapeToDrag][1]+lineWidth;
                libShape[shapeToDrag][4]=libShape[shapeToDrag][2]+lineHeight;
            }
            else{
                libShape[shapeToDrag][1]=mx-dDragX;
                libShape[shapeToDrag][2]=my-dDragY;
            }
        }
        else{
            if(libShape[shapeToDrag][0]==0){ //Γραμμή
                if(libShape[shapeToDrag][6]==0){ //Resize Αρχή
                    libShape[shapeToDrag][1]=mx;
                    libShape[shapeToDrag][2]=my;
                }
                else{                             //Resize Τέλος
                    libShape[shapeToDrag][3]=mx;
                    libShape[shapeToDrag][4]=my;
                }
            }
            else if(libShape[shapeToDrag][0]<500){//Υπόλοιπα Σχήματα
                if(libShape[shapeToDrag][6]==0){ //Resize Πάνω
                    libShape[shapeToDrag][4]=libShape[shapeToDrag][2]+libShape[shapeToDrag][4]-my+dDragY;
                    libShape[shapeToDrag][2]=my-dDragY;
                }
                else if(libShape[shapeToDrag][6]==1){ //Resize Κάτω
                    libShape[shapeToDrag][4]=my-libShape[shapeToDrag][2];
                }
                else if(libShape[shapeToDrag][6]==2){ //Resize Αριστερά
                    libShape[shapeToDrag][3]=libShape[shapeToDrag][1]+libShape[shapeToDrag][3]-mx+dDragX;
                    libShape[shapeToDrag][1]=mx-dDragX;
                }
                else if(libShape[shapeToDrag][6]==3){ //Resize Δεξιά
                    libShape[shapeToDrag][3]=mx-libShape[shapeToDrag][1];
                }
            }
        }
    }
    else if(drawing){
        if(libShape[currentShape][0]==0){
            libShape[currentShape][3]=mx;
            libShape[currentShape][4]=my;
        }
        else{
            libShape[currentShape][3]=mx-libShape[currentShape][1];
            libShape[currentShape][4]=my-libShape[currentShape][2];
        }
        if(shiftPressed){
            if(libShape[currentShape][0]==0){ //Γραμμή
                if(Math.abs(mx-libShape[currentShape][1])<parseInt(pixelPercent*Math.abs(my-libShape[currentShape][2]))){
                    selectedShapeInfo="Κατακόρυφη";
                    libShape[currentShape][3]=libShape[currentShape][1];
                }
                else if(Math.abs(my-libShape[currentShape][2])<parseInt(pixelPercent*Math.abs(mx-libShape[currentShape][1]))){
                    selectedShapeInfo="Οριζόντια";
                    libShape[currentShape][4]=libShape[currentShape][2];
                }
                else if(Math.abs(Math.abs(libShape[currentShape][3]-libShape[currentShape][1])-Math.abs(libShape[currentShape][4]-libShape[currentShape][2]))<parseInt(Math.abs(pixelPercent*(libShape[currentShape][3]-libShape[currentShape][1])))) {
                    selectedShapeInfo="Διαγώνια";
                    libShape[currentShape][4]=parseInt(Math.abs(libShape[currentShape][3]-libShape[currentShape][1])*Math.sign(libShape[currentShape][4]-libShape[currentShape][2]))+libShape[currentShape][2];
                }
                else{
                    selectedShapeInfo="Γραμμή";
                }
            }
            else{ //Υπόλοιπα σχήματα
                if(libShape[currentShape][0]==1){
                    selectedShapeInfo="Τετράγωνο Κουτί";
                }
                else if(libShape[currentShape][0]==2){
                    selectedShapeInfo="Κύκλος";
                }
                else if(libShape[currentShape][0]==3){
                    selectedShapeInfo="Συμπαγές Τετράγωνο Κουτί";
                }
                else if(libShape[currentShape][0]==4){
                    selectedShapeInfo="Συμπαγής Κύκλος";
                }
                libShape[currentShape][4]=parseInt(Math.abs(libShape[currentShape][3])*Math.sign(libShape[currentShape][4]));
            }
        }
        else{
            if(libShape[currentShape][0]==0){
                selectedShapeInfo="Γραμμή";
            }
            else if(libShape[currentShape][0]==1){
                selectedShapeInfo="Κουτί";
            }
            else if(libShape[currentShape][0]==2){
                selectedShapeInfo="Έλλειψη";
            }
            else if(libShape[currentShape][0]==3){
                selectedShapeInfo="Συμπαγές Κουτί";
            }
            else if(libShape[currentShape][0]==4){
                selectedShapeInfo="Συμπαγής Έλλειψη";
            }
        }
    }    
}

function drawLibrary(){
    var i,picID;
    for(i=0;i<currentShape+1;i++){
        drawShape(libShape[i][0],libShape[i][1],libShape[i][2],libShape[i][3],libShape[i][4],libShape[i][7],libShape[i][8],libShape[i][9]);
    }
    if(shapeToDrag>-1){
        drawSelectionMarks();
    }
}

function drawShape(shpSlctr,CurL,CurT,CurW,CurH,r,g,b){
    var X1,Y1;
    cntx.strokeStyle="rgb("+r+","+g+","+b+")";
    cntx.fillStyle="rgb("+r+","+g+","+b+")";
    if(CurW>=0){
        X1=CurL;
    }
    else{
        X1=CurL+CurW;
    }
    if(CurH>=0){
        Y1=CurT;
    }
    else{
        Y1=CurT+CurH;
    }
    if(shpSlctr==0){
        cntx.beginPath();
        cntx.moveTo(CurL,CurT);
        cntx.lineTo(CurW,CurH);
        cntx.stroke();
    }
    else if(shpSlctr==1){
        cntx.beginPath();
        cntx.rect(X1,Y1,Math.abs(CurW),Math.abs(CurH));
        cntx.stroke();
    }
    else if(shpSlctr==2){
        var R1=Math.abs(CurW)/2;
        var R2=Math.abs(CurH)/2;
        cntx.beginPath();
        cntx.ellipse(X1+R1,Y1+R2,R1,R2,0,0,2*Math.PI);
        cntx.stroke();

    }
    else if(shpSlctr==3){
        cntx.beginPath();
        cntx.fillRect(X1,Y1,Math.abs(CurW),Math.abs(CurH));
        cntx.fill();
    }
    else if(shpSlctr==4){
        var R1=Math.abs(CurW)/2;
        var R2=Math.abs(CurH)/2;
        cntx.beginPath();
        cntx.ellipse(X1+R1,Y1+R2,R1,R2,0,0,2*Math.PI);
        cntx.fill();
    }
}

function drawSelectionMarks(){
    cntx.strokeStyle="rgb(0,0,0)";
    if(libShape[shapeToDrag][0]==0){
        //Γραμμή
        //ΕΣΩΤΕΡΙΚΟ
        setFillColor(0);
        cntx.beginPath();
        cntx.fillRect(libShape[shapeToDrag][1]-selectorSize/2,libShape[shapeToDrag][2]-selectorSize/2,selectorSize,selectorSize);
        cntx.fill();
        setFillColor(1);
        cntx.beginPath();
        cntx.fillRect(libShape[shapeToDrag][3]-selectorSize/2,libShape[shapeToDrag][4]-selectorSize/2,selectorSize,selectorSize);
        cntx.fill();
        //ΕΞΩΤΕΡΙΚΟ ΠΕΡΙΓΡΑΜΜΑ
        cntx.strokeStyle="rgb(0,0,0)";
        cntx.beginPath();
        cntx.rect(libShape[shapeToDrag][1]-selectorSize/2,libShape[shapeToDrag][2]-selectorSize/2,selectorSize,selectorSize);
        cntx.stroke();
        cntx.beginPath();
        cntx.rect(libShape[shapeToDrag][3]-selectorSize/2,libShape[shapeToDrag][4]-selectorSize/2,selectorSize,selectorSize);
        cntx.stroke();
    }
    else{
        //Υπόλοιπα σχήματα
        //Περίγραμμα
        cntx.strokeStyle="rgb(0,0,0)";
        cntx.beginPath();
        cntx.rect(libShape[shapeToDrag][1],libShape[shapeToDrag][2],libShape[shapeToDrag][3],libShape[shapeToDrag][4]);
        cntx.stroke();
        
        if(libShape[shapeToDrag][0]<500) {
            //ΕΣΩΤΕΡΙΚΟ
            //Πάνω
            setFillColor(0);
            cntx.beginPath();
            cntx.fillRect(libShape[shapeToDrag][1]+(libShape[shapeToDrag][3]-selectorSize)/2,libShape[shapeToDrag][2]-selectorSize/2,selectorSize,selectorSize);
            cntx.fill();
            //Κάτω
            setFillColor(1);
            cntx.beginPath();
            cntx.fillRect(libShape[shapeToDrag][1]+(libShape[shapeToDrag][3]-selectorSize)/2,libShape[shapeToDrag][2]+libShape[shapeToDrag][4]-selectorSize/2,selectorSize,selectorSize);
            cntx.fill();
            //Αριστερά
            setFillColor(2);
            cntx.beginPath();
            cntx.fillRect(libShape[shapeToDrag][1]-selectorSize/2,libShape[shapeToDrag][2]+(libShape[shapeToDrag][4]-selectorSize)/2,selectorSize,selectorSize);
            cntx.fill();
            //Δεξιά
            setFillColor(3);
            cntx.beginPath();
            cntx.fillRect(libShape[shapeToDrag][1]+libShape[shapeToDrag][3]-selectorSize/2,libShape[shapeToDrag][2]+(libShape[shapeToDrag][4]-selectorSize)/2,selectorSize,selectorSize);
            cntx.fill();
            
            //ΕΞΩΤΕΡΙΚΟ ΠΕΡΙΓΡΑΜΜΑ
            //Πάνω
            cntx.strokeStyle="rgb(0,0,0)";
            cntx.beginPath();
            cntx.rect(libShape[shapeToDrag][1]+(libShape[shapeToDrag][3]-selectorSize)/2,libShape[shapeToDrag][2]-selectorSize/2,selectorSize,selectorSize);
            cntx.stroke();

            //Κάτω
            cntx.beginPath();
            cntx.rect(libShape[shapeToDrag][1]+(libShape[shapeToDrag][3]-selectorSize)/2,libShape[shapeToDrag][2]+libShape[shapeToDrag][4]-selectorSize/2,selectorSize,selectorSize);
            cntx.stroke();
            //Αριστερά
            cntx.beginPath();
            cntx.rect(libShape[shapeToDrag][1]-selectorSize/2,libShape[shapeToDrag][2]+(libShape[shapeToDrag][4]-selectorSize)/2,selectorSize,selectorSize);
            cntx.stroke();
            //Δεξιά
            cntx.beginPath();
            cntx.rect(libShape[shapeToDrag][1]+libShape[shapeToDrag][3]-selectorSize/2,libShape[shapeToDrag][2]+(libShape[shapeToDrag][4]-selectorSize)/2,selectorSize,selectorSize);
            cntx.stroke();
        }
    }
}

function setFillColor(markIndex){
    var borderColor=(libShape[shapeToDrag][5]+2) % noOfPaletteColors;
    if(libShape[shapeToDrag][6]==markIndex){
        borderColor=(libShape[shapeToDrag][5]+5) % noOfPaletteColors;
    }
    else{
        borderColor=(libShape[shapeToDrag][5]+2) % noOfPaletteColors;
    }
    cntx.fillStyle="rgb("+paletteR[borderColor]+","+paletteG[borderColor]+","+paletteB[borderColor]+")";
}

function trimNegatives(shpIndx){
    var L,T,W,H;
    L=Math.min(libShape[shpIndx][1],libShape[shpIndx][1]+libShape[shpIndx][3]);
    T=Math.min(libShape[shpIndx][2],libShape[shpIndx][2]+libShape[shpIndx][4]);
    W=Math.abs(libShape[shpIndx][3]);
    H=Math.abs(libShape[shpIndx][4]);
    libShape[shpIndx][1]=L;
    libShape[shpIndx][2]=T;
    libShape[shpIndx][3]=W;
    libShape[shpIndx][4]=H;
}

function actionPerformed(btnSlctr){
    if(btnSlctr=="btnDeleteImage"){
        deleteImage();
    }
    else if(btnSlctr=="btnNewFlag"){
        deleteImage();
        selectFlag();
        additionalInfo="";
    }
    else if(btnSlctr=="btnShowSolution"){
        additionalInfo=flagName[selectedFlag];
    }
    drawBasicScreen();
}

function deleteImage(){
    currentShape=-1;
    shapeToDrag=-1;
    mVisible=false;
}

function selectFlag(){
    if(noOfUsedFlags==noOfFlags) resetFlagUsage();
    do{
        selectedFlag=parseInt(Math.random()*noOfFlags);
    }while(flagUsed[selectedFlag]);
    flagUsed[selectedFlag]=true;
    noOfUsedFlags++;
    flagPic=document.getElementById("flag"+selectedFlag);
    $("#flagSelector").val("noFlag");
    $("#flagSelector").css("color","blue");
}

function roundRect(x,y,width,height,radius,fill,stroke){
    if(typeof stroke=="undefined"){
        stroke=true;
    }
    if(typeof radius==="undefined"){
        radius=5;
    }
    if (typeof radius==="number"){
        radius={tl: radius, tr: radius, br: radius, bl: radius};
    }
    else{
        var defaultRadius={tl:0, tr:0, br:0, bl:0};
        for(var side in defaultRadius){
            radius[side]=radius[side] || defaultRadius[side];
        }
    }
    cntx.beginPath();
    cntx.moveTo(x+radius.tl,y);
    cntx.lineTo(x+width-radius.tr,y);
    cntx.quadraticCurveTo(x+width,y,x+width,y+radius.tr);
    cntx.lineTo(x+width,y+height-radius.br);
    cntx.quadraticCurveTo(x+width,y+height,x+width-radius.br,y+height);
    cntx.lineTo(x+radius.bl,y+height);
    cntx.quadraticCurveTo(x,y+height,x,y+height-radius.bl);
    cntx.lineTo(x,y+radius.tl);
    cntx.quadraticCurveTo(x,y,x+radius.tl,y);
    cntx.closePath();
    if(fill){
      cntx.fill();
    }
    if(stroke){
      cntx.stroke();
    }
  }

function drawGrid(){
    var grey=180;
    cntx.strokeStyle="rgb("+grey+","+grey+","+grey+")";
    cntx.beginPath();
    for(var x=flagLeft;x<width;x+=gridStep){
        cntx.moveTo(x,TopPanelHeight+1);
        cntx.lineTo(x,BottomPanelTop-1);
    }
    for(var y=flagTop;y<BottomPanelTop;y+=gridStep){
        cntx.moveTo(0,y);
        cntx.lineTo(width,y);
    }
    cntx.stroke();
}

function resetFlagUsage(){
    noOfUsedFlags=0;
    for(var i=0;i<noOfFlags;i++){
        flagUsed[i]=false;
    }
}

function initialiseFlags(){
    resetFlagUsage();
    flag[0]="ivorycoast";
    flag[1]="armenia";
    flag[2]="austria";
    flag[3]="tonga";
    flag[4]="belgium";
    flag[5]="bulgaria";
    flag[6]="france";
    flag[7]="germany";
    flag[8]="georgia";
    flag[9]="yugoslavia";
    flag[10]="gambia";
    flag[11]="gabon";
    flag[12]="guinea";
    flag[13]="denmark";
    flag[14]="switzerland";
    flag[15]="greece";
    flag[16]="estonia";
    flag[17]="uae";
    flag[18]="usa";
    flag[19]="uk";
    flag[20]="japan";
    flag[21]="indonesia";
    flag[22]="ireland";
    flag[23]="iceland";
    flag[24]="italy";
    flag[25]="colombia";
    flag[26]="laos";
    flag[27]="latvia";
    flag[28]="libya";
    flag[29]="lithuania";
    flag[30]="luxemburg";
    flag[31]="madagaskar";
    flag[32]="mali";
    flag[33]="malta";
    flag[34]="mauritius";
    flag[35]="monaco";
    flag[36]="bangladesh";
    flag[37]="benin";
    flag[38]="botswana";
    flag[39]="niger";
    flag[40]="nigeria";
    flag[41]="norway";
    flag[42]="netherlands";
    flag[43]="hungary";
    flag[44]="ukraine";
    flag[45]="paraguay";
    flag[46]="poland";
    flag[47]="romania";
    flag[48]="russia";
    flag[49]="serbia";
    flag[50]="sierraleone";
    flag[51]="sweden";
    flag[52]="thailand";
    flag[53]="chad";
    flag[54]="yemen";
    flag[55]="finland";

    flagName[0]="Ακτή Ελεφαντοστού";
    flagName[1]="Αρμενία";
    flagName[2]="Αυστρία";
    flagName[3]="Βασίλειο των Τόνγκα";
    flagName[4]="Βέλγιο";
    flagName[5]="Βουλγαρία";
    flagName[6]="Γαλλία";
    flagName[7]="Γερμανία";
    flagName[8]="Γεωργία";
    flagName[9]="Γιουγκοσλαβία";
    flagName[10]="Γκάμπια";
    flagName[11]="Γκαμπόν";
    flagName[12]="Γουινέα";
    flagName[13]="Δανία";
    flagName[14]="Ελβετία";
    flagName[15]="Ελλάδα";
    flagName[16]="Εσθονία";
    flagName[17]="Ηνωμένα Αραβικά Εμιράτα";
    flagName[18]="Ηνωμένες Πολιτείες της Αμερικής";
    flagName[19]="Ηνωμένο Βασίλειο";
    flagName[20]="Ιαπωνία";
    flagName[21]="Ινδονησία";
    flagName[22]="Ιρλανδία";
    flagName[23]="Ισλανδία";
    flagName[24]="Ιταλία";
    flagName[25]="Κολομβία";
    flagName[26]="Λάος";
    flagName[27]="Λετονία";
    flagName[28]="Λιβύη";
    flagName[29]="Λιθουανία";
    flagName[30]="Λουξεμβούργο";
    flagName[31]="Μαδαγασκάρη";
    flagName[32]="Μαλί";
    flagName[33]="Μάλτα";
    flagName[34]="Μαυρίκιος";
    flagName[35]="Μονακό";
    flagName[36]="Μπανγκλαντές";
    flagName[37]="Μπενίν";
    flagName[38]="Μποτσουάνα";
    flagName[39]="Νίγηρας";
    flagName[40]="Νιγηρία";
    flagName[41]="Νορβηγία";
    flagName[42]="Ολλανδία";
    flagName[43]="Ουγγαρία";
    flagName[44]="Ουκρανία";
    flagName[45]="Παραγουάη";
    flagName[46]="Πολωνία";
    flagName[47]="Ρουμανία";
    flagName[48]="Ρωσσία";
    flagName[49]="Σερβία";
    flagName[50]="Σιέρα Λεόνε";
    flagName[51]="Σουηδία";
    flagName[52]="Ταϊλάνδη";
    flagName[53]="Τσαντ";
    flagName[54]="Υεμένη";
    flagName[55]="Φινλανδία";
    
    populateFlagList();
}

function populateFlagList(){
    var html="<option value='noFlag'>(ονομασία χώρας)</option>";
    for(var i=0;i<noOfFlags;i++){
        html+="<option value='"+flag[i]+"'>"+flagName[i]+"</option>";
    }
    $("#flagSelector").html(html);
}

function showColorInfo(){
	var paletteSide=15;
	var paletteLeft=$("#colorSelectorDIV").position().left+$("#colorSelectorDIV").width()+border;
	var paletteTop=$("#colorSelectorDIV").position().top-border;
	cntx.fillStyle="rgb("+parseInt($("#HscrRed").val())+",0,0)";
	cntx.fillRect(paletteLeft,paletteTop,paletteSide,paletteSide);
	cntx.fillStyle="rgb(0,"+parseInt($("#HscrGreen").val())+",0)";
	cntx.fillRect(paletteLeft,paletteTop+(paletteSide+border),paletteSide,paletteSide);
	cntx.fillStyle="rgb(0,0,"+parseInt($("#HscrBlue").val())+")";
	cntx.fillRect(paletteLeft,paletteTop+2*(paletteSide+border),paletteSide,paletteSide);
	
	cntx.fillStyle="rgb("+parseInt($("#HscrRed").val())+","+parseInt($("#HscrGreen").val())+","+parseInt($("#HscrBlue").val())+")";
	cntx.fillRect(paletteLeft+paletteSide+2*border,paletteTop,2*paletteSide,3*paletteSide+2*border);
}

function itemStateChanged(slctr){
    if(slctr=="flagSelector"){
        if($("#flagSelector").val().toLowerCase()==flag[selectedFlag].toLowerCase()){
            $("#flagSelector").css("color","blue");
            additionalInfo="(Σωστά)";
        }
        else{
            $("#flagSelector").css("color","red");
            additionalInfo="(Ξαναπροσπάθησε)";
        }
        drawBasicScreen();
    }
}

function drawFlag(){
    cntx.drawImage(flagPic,400,TopPanelHeight+10);
    //Σχεδίαση Πλαισίου
    if(selectedFlag==14) {//Ελβετία
        flagWidth=240;
    }
    else {
        flagWidth=376;
    }
    cntx.strokeStyle="rgb(0,0,0)";
    cntx.beginPath();
    cntx.rect(flagLeft,flagTop,flagWidth,flagHeight);
    cntx.stroke();
}

function showProgram(){
    var sourceCode="";
    codeFillStyle=false;
    var colorChange;
    var i;
    var currentRed=-1,currentGreen=-1,currentBlue=-1;
    for(i=0;i<currentShape+1;i++){
        if(sourceCode!="") sourceCode=sourceCode+"<br>";
        colorChange=false;
		colorChange=colorChange | libShape[i][7]!=currentRed;
		colorChange=colorChange | libShape[i][8]!=currentGreen;
		colorChange=colorChange | libShape[i][9]!=currentBlue;			
        
        if(colorChange){
			currentRed=libShape[i][7];
			currentGreen=libShape[i][8];
			currentBlue=libShape[i][9];
            sourceCode=sourceCode+"Χρώμα "+currentRed+" , "+currentGreen+" , "+currentBlue+"<br>";
        }
        sourceCode=sourceCode+assembleCommand(libShape[i][0],libShape[i][1],libShape[i][2],libShape[i][3],libShape[i][4]);
    }
    $("#sourceCodeDIV").html(sourceCode);
}

function assembleCommand(shpSlctr,CurL,CurT,CurW,CurH){
    var command="";
    var X1,Y1;
    if(CurW>=0){
        X1=CurL;
    }
    else{
        X1=CurL+CurW;
    }
    if(CurH>=0){
        Y1=CurT;
    }
    else{
        Y1=CurT+CurH;
    }
    if(shpSlctr==0){
        command="Γραμμή "+CurL+" , "+CurT+" , "+CurW+" , "+CurH;
    }
    else if(shpSlctr==1){
        if(codeFillStyle) command="Γέμισμα:ΟΧΙ<br>";
        command+="Κουτί "+X1+" , "+Y1+" , "+Math.abs(CurW)+" , "+Math.abs(CurH);
        codeFillStyle=false;
    }
    else if(shpSlctr==2){
        if(codeFillStyle) command="Γέμισμα:ΟΧΙ<br>";
        command+="Έλλειψη "+X1+" , "+Y1+" , "+Math.abs(CurW)+" , "+Math.abs(CurH);
        codeFillStyle=false;
    }
    else if(shpSlctr==3){
        if(!codeFillStyle) command="Γέμισμα:ΝΑΙ<br>";
        command+="Κουτί "+X1+" , "+Y1+" , "+Math.abs(CurW)+" , "+Math.abs(CurH);
        codeFillStyle=true;
    }
    else{//if (shpSlctr==4){
        if(!codeFillStyle) command="Γέμισμα:ΝΑΙ<br>";
        command+="Έλλειψη "+X1+" , "+Y1+" , "+Math.abs(CurW)+" , "+Math.abs(CurH);
        codeFillStyle=true;
    }
    return command;
}

function rangeValueChanged(slctr){
	if(slctr=="HscrRed"){
		
	}
	else if(slctr=="HscrGreen"){
		
	}
	else if(slctr=="HscrBlue"){
		
	}
	drawBasicScreen();
}